public class Person 
{
    private int yearOfBirth;
    
    private String name;
    
    private Address address;
    
    public Person(String name, int yob, Address address) {
        this.name = name;
        this.address = address;
        this.yearOfBirth = yob;
    }
    
    public String getName() {
        return this.name;
    }
    
    public Address getAddress() {
        return address;
    }
    
    public boolean equals(Object obj) {
        if (!(obj instanceof Person)) return false;
        
        if (obj == this) return true;
        
        Person p = (Person) obj;
        return (yearOfBirth == p.yearOfBirth && 
                name.equals(p.name) &&
                address.equals(p.address));
    }
    
    public int hashCode() {
        int hash = 343;
        hash = hash * 31 + yearOfBirth;
        hash = hash * 31 + name.hashCode();
        hash = hash * 31 + address.hashCode();
        return hash;
    }
}